<!DOCTYPE html>
<html lang="en">
  <!-- Copyright 2017 Damien Andre. This file is part of Mechamatic. -->

  <!-- Mechamatic is free software: you can redistribute it and/or modify -->
  <!-- it under the terms of the GNU General Public License as published by -->
  <!-- the Free Software Foundation, either version 3 of the License, or -->
  <!-- () any later version. -->
  
  <!-- Mechamatic is distributed in the hope that it will be useful, -->
  <!-- but WITHOUT ANY WARRANTY; without even the implied warranty of -->
  <!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the -->
  <!-- GNU General Public License for more details. -->
  
  <!-- You should have received a copy of the GNU General Public License -->
  <!-- along with Mechamatic.  If not, see <http://www.gnu.org/licenses/>. -->

  <head>

    <meta charset="utf-8">
    <link rel="icon" type="image/svg+xml" href="./img/logo.svg">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="Online impulse excitation test for mechanical characterization">
    <meta name="author" content="Damien André">

    <title>Mechamatic</title>

    <!-- Bootstrap core CSS -->
    <link href="vendor/bootstrap/css/bootstrap.min.css" rel="stylesheet">

    <!-- Custom fonts for this template -->
    <link href="vendor/font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">
    <link href="vendor/academicons/css/academicons.min.css" rel="stylesheet" type="text/css">
    

    <!-- Custom styles for this template -->
    <link href="css/grayscale.css" rel="stylesheet">
    <link href="css/custom.css" rel="stylesheet">
    <link href="css/loading.css" rel="stylesheet">
    <link href="css/loading-btn.css" rel="stylesheet">
  </head>

  <body id="page-top">
  
    

    
    <!-- Navigation -->
    <nav class="navbar navbar-expand-lg navbar-light fixed-top" id="mainNav">
      <div class="col-lg-8 text-left">
        <button class="navbar-toggler" id="menu" type="button" data-toggle="collapse" data-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false" aria-label="Toggle navigation">
          Menu
          <i class="fa fa-bars"></i>
        </button>
      	<a href="#" class="navbar-left" id="title"><strong>Mechamatic</strong></a>
        <div class="collapse navbar-collapse" id="navbarResponsive">
          <ul class="navbar-nav ml-auto">
	    <li class="nav-item">
              <a class="nav-link" href="index.html"><i class="fa fa-home fa-fw" aria-hidden="true"></i> Home</a>
            </li>
	    <li class="nav-item">
              <a class="nav-link" href="acoustic.html"><i class="fa fa-music fa-fw" aria-hidden="true"></i> Acoustic method</a>
            </li>
	    <li class="nav-item">
              <a class="nav-link" href="optic.html"><i class="fa fa-camera fa-fw" aria-hidden="true"></i> Optic method</a>
            </li>
          </ul>
        </div>
      </div>
      <div class="help-tip" data-toggle="modal" data-target="#helpModal">
	<p>Click here to get some help !</p>
      </div>
    </nav>
    

    <!-- Intro Header -->
    <header class="masthead rfda">
      <div class="intro-body">
        <div class="container">
          <div class="row">
            <div class="col-lg-8 mx-auto">
              <h1 class="brand-heading">Acoustic method</h1>
	      <div class="loader"></div>
	      <p>loading page...</p>
            </div>
          </div>
        </div>
      </div>
    </header>

    
    <section id="measure" class="content-section-white text-left rfda">
      <div class="container">
	<div class="row">
          <div class="col-lg-12 mx-auto">
	    <h1><i class="fa fa-music fa-fw" aria-hidden="true"></i>Measure</h1>
	    <hr>
	    <form>
	      <div class="form-group row">
		<div class="col-md-4">
		  <label for="length">Length</label>
		  <div class="input-group">
		    <input type="number" class="form-control" id="length" value="150" step="0.1" min="0.1" max="10000">
		    <span class="input-group-addon">mm</span>
		  </div>
		</div>

		<div class="col-md-4">
		  <label for="width">width</label>
		  <div class="input-group">
		    <input type="number" class="form-control" id="width" value="50" step="0.1" min="0.1" max="10000">
		    <span class="input-group-addon">mm</span>
		  </div>
		</div>

		<div class="col-md-4">
		  <label for="thickness">thickness</label>
		  <div class="input-group">
		    <input type="number" class="form-control" id="thickness" value="4" step="0.1" min="0.1" max="10000">
		    <span class="input-group-addon">mm</span>
		  </div>
		</div>

		<div class="col-md-4">
		  <label for="mass">mass</label>
		  <div class="input-group">
		    <input type="number" class="form-control" id="mass" value="81" step="0.1" min="0.1" max="100000">
		    <span class="input-group-addon">g</span>
		  </div>
		</div>

		<div class="col-md-4">
		  <label for="duration">duration</label>
		  <div class="input-group">
		    <input type="number" class="form-control" id="duration" value="4" step="1" min="1" max="10">
		    <span class="input-group-addon">s</span>
		  </div>
		</div>

		<div class="col-md-4">
		  <label for="duration">test</label>
		  <select class="custom-select input-group" id="test-type">
		    <option value="bending" selected>bending</option>
		    <option value="torsion"         >torsion</option>
		  </select>
		</div>

		<div class="col-lg-12 mx-auto"><hr></div>
		
		<div class="col-md-12 text-center mt-5"></div>
		<div class="col-lg-12 mx-auto text-center mt-2">
		  <div type="button" class="btn btn-lg btn-primary ld-ext-right"
		       onclick="toggleRecording(this);" id="record" style="width:75%;">
		    Record <i class="fa fa-microphone fa-fw" aria-hidden="true"></i>
		    <div class="ld ld-ring ld-spin">
		    </div>
		  </div>
		</div>
		
		
	      </div>
	      <div class="col-lg-12 mx-auto text-center">
		<div id="record-notify" class="notify">Please record something now...</div>
	      </div>
	    </form>


	    
	    <div class="modal fade" id="myModal" role="dialog">
	      <div class="modal-dialog">
		<!-- Modal content-->
		<div class="modal-content">
		  <div class="modal-body">
		    <p>Done, you can consult the results now !</p>
		    <a href="#results" id="go-to-measure" class="js-scroll-trigger"
		       style="display:none;">&raquo;</a>
		  </div>
		  <div class="modal-footer">
		    <button type="button" class="btn btn-default"
			    data-dismiss="modal">I got it</button>
		  </div>
		</div>
		
	      </div>
	    </div>
          </div>
	</div>
    </section>
    
    


    <!-- Result Section -->
    <section id="results" class="download-section content-section text-left">
      <div class="container">
        <div class="col-lg-12 mx-auto">
	  <h1><i class="fa fa-line-chart fa-fw" aria-hidden="true"></i> Results </h1>

	
	  
	  <p id="msg"><emph>Results are not yet available.
	      Please record something before consulting result.</emph></p>

	  <div class="dropdown" id="drop-result" style="visibility:hidden;">
	    <button class="btn btn-success dropdown-toggle" type="button" id="drop-result-btn" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
	      Display more result
	    </button>
	    <div class="dropdown-menu" aria-labelledby="drop-result-btn">
	      <h6 class="dropdown-header">Choose your results</h6>
	      <div class="dropdown-divider"></div>
	      <a class="dropdown-item" onclick="plot_temp();"><i class="fa fa-area-chart fa-fw" aria-hidden="true"></i> plot temporal chart</a>
	      <a class="dropdown-item" onclick="plot_freq();"><i class="fa fa-area-chart fa-fw" aria-hidden="true"></i> plot spectral chart</a>
	      <a class="dropdown-item" onclick="display_result();"><i class="fa fa-times-circle fa-fw" aria-hidden="true"></i> hide chart</a>
	    </div>
	  </div>

	  <div id="plot" class="plot"></div>
	  
        </div>
      </div>
    </section>
    
    <!-- HELP -->
    <div class="modal fade" id="helpModal" >
      <div class="modal-dialog" role="document">
	<div class="modal-content">
	  <div class="modal-header">
	    <h5 class="modal-title" id="exampleModalLabel">Help</h5>
	    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
	      <span aria-hidden="true">&times;</span>
	    </button>
	  </div>
	  <div class="modal-body">
	    <p>
	      The <a href="http://en.wikipedia.org/wiki/Impulse_excitation_technique">impulse excitation
		technique</a> (IET) is a smart and easy acoustic method to measure
	      the <a href="https://en.wikipedia.org/wiki/Young%27s_modulus">Young's
		modulus</a> and the <a href="https://en.wikipedia.org/wiki/Shear_modulus">shear
		modulus</a> of materials. The IET method uses the sound emitted at the 
	      natural frequencies of an impacted piece of material.
	    </p>
	    <p>
	      In order to measure the elastic constants of your material,
	      you must fill the following input : <span class="badge badge-primary">length</span>,
	      <span class="badge badge-primary">width</span>, <span class="badge badge-primary">thickness</span>
	      and <span class="badge badge-primary">mass</span> of your sample. In addition,
	      you can choose a record <span class="badge badge-primary">duration</span>.
	      Note that a value between 3 and 5 seconds is a good value for duration. Finally,
	      you can record the sound emitted by your sample by pressing the <span class="badge badge-primary">record</span>
	      button. 
	    </p>
	    <p>
	      Now, you can go below to get more information about
	      the specific setups for measuring the Young's modulus and/or the shear modulus.
	    </p>
	    <img src="img/sample.svg" alt="The sample"> 

	    <div class="mt-5"></div>
	    <h2 class="mt-5">Bending setup</h2>
	    <p>
	      In order to measure the <strong>Young's modulus</strong>, you need to prepare the
	      following setup and choose the <span class="badge badge-primary">Bending</span> option.
	    </p>

	    <img src="img/bending.svg" alt="The bending setup"> 
	    <p> 
	      Your sample must have a parallelepiped shape with a small
	      thickness. The two supports, placed in a parallel position, must be placed under the sample. You need
	      to measure with a high precision the distance between the supports as
	      it is shown on the figure above.
	    </p>
	    <p>
	      To produce the sound, you must hit the sample with a small hammer at the center 
	      of the sample. The microphone must be placed also at the center of the sample.
	    </p>

	    <div class="mt-5"></div>
	    <h2>Torsion setup</h2>
	    <p>
	      In order to measure the <strong>shear modulus</strong>, you need to prepare the
	      following setup and choose the <span class="badge badge-primary">Torsion</span> option.
	    </p>

	    <img src="img/torsion.svg" alt="The torsion setup"> 
	    <p> 
	      Your sample must have a parallelepiped shape with a small
	      thickness. The two supports, placed in a cross position, must be placed under the sample. You need
	      to measure with a high precision the distance between the supports as
	      it is shown on the figure above.
	    </p>
	    <p>
	      To produce the sound, you must hit the sample with a small hammer at one
	      of the corners of the sample. The microphone must be placed at the opposite corner
	      of the sample. 
	    </p>	    

	    <div class="mt-5"></div>
	    <h2>Results</h2>
	    <p>
	      After recording the sound you have to wait few seconds. The results will appear
	      below the form. These results are : the Young's modulus or the shear modulus
	      (depending on your choice), a graph that shows the temporal signal of your sound and
	      a graph that shows the spectral signal of your sound.
	    </p>

	    <div class="mt-5"></div>
	    <h2>3D print your own apparatus</h2>
	    <p>
	      To get started, the supports can be simply two small
	      cylinders. Plastic cylinders work well. If you want more elegant
	      setup, you can 3D print <a href="dl/cad.zip"> these cad files</a>.
	      It gives the following apparatus.
	    </p>
	    <img src="img/apparatus.png" alt="The 3D printing apparatus"> 
	  </div>
	  <div class="modal-footer">
	    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
	  </div>
	</div>
      </div>
    </div>
    

    

    <!-- Footer -->
    <footer>
      <div class="container text-center">
	<p>Licensed under the <a rel="license" href="./license.txt">GNU-GPL v3 license</a></p>
	<p>Copyright &copy; Damien Andr&eacute; 2017</p>
      </div>
    </footer>

    <!-- Bootstrap core JavaScript -->
    <script src="vendor/jquery/jquery.min.js"></script>
    <script src="vendor/popper/popper.min.js"></script>
    <script src="./vendor/bootstrap/js/tether.min.js"></script>
    <script src="vendor/bootstrap/js/bootstrap.min.js"></script>

    <!-- Plugin JavaScript -->
    <script src="vendor/jquery-easing/jquery.easing.min.js"></script>

    <!-- Plotly JS-->
    <script src="vendor/plotly/plotly-1.2.0.min.js"></script>


    <!-- Custom scripts for this template -->
    <script src="js/grayscale.js"></script>
    <script src="js/common.js"></script>
    <script src="js/acoustic/recorder.js"></script>
    <script src="js/acoustic/main.js"></script>
    <script src="js/acoustic/ws-client.js"></script>
    
    
  </body>

</html>
